#include <iostream>
#include <boost/shared_ptr.hpp>
#include "test.h"

class Destructor
{
public:
    Destructor()
    {
        std::cout << "Destructor's constructor called" << std::endl;
    }

    Destructor(const Destructor& other)
    {
        std::cout << "Destructor's copy constructor called" << std::endl;
    }

    void operator()(Test* t)
    {
        std::cout << "Destructors operator() called" << std::endl;
        delete t;
    }

    ~Destructor()
    {
        std::cout << "Destructor's destructor called" << std::endl;
    }
};

int main(int argc, char* argv[])
{
    Destructor d;
    boost::shared_ptr<Test> t1(new Test(1), d);

    return 0;
}


